-- Enqueue some rows
USE Concurrency2
GO

-- Show the table design

/***

CREATE TABLE [dbo].[QueueTable](
	[QueueID] [bigint] IDENTITY(1,1) NOT NULL,
	[Payload] [varchar](1000) NULL,
	PRIMARY KEY CLUSTERED 
			( [QueueID] ASC )
) 

***/


INSERT	dbo.QueueTable (Payload)
VALUES ('First Row'), ('Second Row'), ('Third Row')
GO

INSERT	dbo.QueueTable (Payload)
VALUES ('Fourth Row'), ('Fifth Another')

BEGIN TRAN

;WITH cte AS (
    SELECT TOP(1) QueueID, Payload
      FROM dbo.QueueTable WITH (ROWLOCK, READPAST)
    ORDER BY QueueID)
  DELETE FROM cte
    OUTPUT deleted.QueueID, deleted.Payload

-- Do some processing

COMMIT TRAN 

SELECT * FROM dbo.QueueTable;